#!/usr/bin/perl

# ypAnything, an NIS gateway to non-NIS sources.
# Copyright (C) 2004  Jeff McElroy <jmcelroy11@sio.midco.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

sub getLDAP {

	$host         = shift;
	$port         = shift;
	$bindDN       = shift;
	$bindPassword = shift;
	$base         = shift;
	$searchType   = shift;

	print "ldapsearch -LLL -x -h $host -p $port -D '$bindDN' -w $bindPassword -b $base -s $searchType objectClass=posixGroup cn userpassword gidnumber memberuid";
	open(LDAP,"ldapsearch -LLL -x -h $host -p $port -D '$bindDN' -w $bindPassword -b $base -s $searchType objectClass=posixGroup cn userpassword gidnumber memberuid|") || die $!;
	while(<LDAP>)
	{
		if (/^\s*$/)
		{
			if (defined(%u))
			{
				if ("$u{userpassword}" eq "") { $u{userpassword} = "x";}
                		$u{userpassword} =~ s/\{crypt\}//ig;
				print "$u{cn}:$u{userpassword}:$u{gidnumber}:$members\n";
				undef $members;
				undef %u;
			}
		}
		elsif (/(^[^:]+):\s*(.*)/)
		{
               		$u{$1}=$2;
                	if ($1 eq "memberuid")
                	{
                       		 if (defined($members))
                        	{
                               		 $members .= ",";
                        	}
                        	$members .= $2;
			}
		}
	}
	close(LDAP);
	
	if (defined(%u))
	{
		if ("$u{userpassword}" eq "") { $u{userpassword} = "x";}
		$u{userpassword} =~ s/\{crypt\}//ig;
		print "$u{cn}:$u{userpassword}:$u{gidnumber}:$members\n";
		undef $members;
        	undef undef;
	}   
}

getLDAP ("localhost", 389, "cn=Directory Manager", "secret", "o=acme.com", "sub"); 

