#!/usr/bin/perl

# ypAnything, an NIS gateway to non-NIS sources.
# Copyright (C) 2004  Jeff McElroy <jmcelroy11@sio.midco.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

use MIME::Base64;

sub getLDAP {

	$host         = shift;
	$port         = shift;
	$bindDN       = shift;
	$bindPassword = shift;
	$base         = shift;
	$searchType   = shift;

	#print "ldapsearch -x -LLL -h $host -p $port -D '$bindDN' -w $bindPassword -b $base -s $searchType objectClass=posixAccount uid userpassword uidnumber gidnumber gecos homedirectory loginshell\n";

	open(LDAP,"ldapsearch -x -LLL -h $host -p $port -D '$bindDN' -w $bindPassword -b $base -s $searchType objectClass=posixAccount uid userpassword uidnumber gidnumber gecos homedirectory loginshell|") || die $!;
	while(<LDAP>)
	{
		if (/^\s*$/)
		{
			if (defined(%u))
			{
				if ("$u{userpassword}" eq "") { $u{userpassword} = "x";}
                		$u{userpassword} =~ s/\{crypt\}//ig;
				print "$u{uid}:$u{userpassword}:$u{uidnumber}:$u{gidnumber}:$u{gecos}:$u{homedirectory}:$u{loginshell}\n";
				undef %u;
			}
		}
		elsif (/(^[^:]+)::\s*(.*)/)
		{
			$u{$1} = MIME::Base64::decode($2);
		}
		elsif (/(^[^:]+):\s*(.*)/)
		{
			$u{$1}=$2;
		}
	}
	close(LDAP);
	
	if (defined(%u))
	{
		if ("$u{userpassword}" eq "") { $u{userpassword} = "x";}
		$u{userpassword} =~ s/\{crypt\}//g;
        	print "$u{uid}:$u{userpassword}:$u{uidnumber}:$u{gidnumber}:$u{gecos}:$u{homedirectory}:$u{loginshell}\n";
        	undef %u;
	}   
}

getLDAP ("localhost", 389, "cn=Directory Manager", "secret", "o=acme.com", "sub"); 

