%{

/*
  Lexicon for ypanywhere.conf
 
  Jeff McElroy
  jmcelroy11@sio.midco.net
 
*/

#include <string.h>

#include "y.tab.h"

int G_configLineNo=1;
char G_yyString[1024];
int G_yyInteger=0;
%}

%%

\n                        G_configLineNo++;
[ \t]                     ;
#.*$                      ; 
debug                     { return DEBUG ; }
debug_file                { return DEBUG_FILE ; }
domain                    { return DOMAIN_T ; }
map                       { return MAP_T ; }
index                     { return INDEX_T ; }
script                    { return SCRIPT ; }
refresh                   { return REFRESH ; }
memblock_size             { return MEMBLOCK_SIZE ; }
ioblock_size              { return IOBLOCK_SIZE ; }
deliminator               { return DELIMINATOR ; }
field                     { return FIELD ; }
\".*\"|'.*'               { 
                              strncpy(G_yyString, yytext+1, sizeof(G_yyString)); 
                              if (yyleng > 2) 
                              {
                                G_yyString[yyleng-2]='\0';
                              }
                              return STRING; 
                          }
[+-]?[0-9]+               { G_yyInteger = atoi(yytext); return INTEGER; }
.                         { return yytext[0];}

