/*
  heap.h
  Jeff McElroy
  jmcelroy11@sio.midco.net
*/

/*
    ypanything, an NIS gateway to non-NIS sources
    Copyright (C) 2004  Jeff McElroy <jmcelroy11@sio.midco.net>
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA                                                                 
*/

/*
  memory allocation routines
*/

#define MEMTYPE_UNDEFINED                  0
#define MEMTYPE_DATA                       1
#define MEMTYPE_DOMAIN                     2
#define MEMTYPE_DOMAINNAME                 3
#define MEMTYPE_MAP                        4
#define MEMTYPE_MAPNAME                    5
#define MEMTYPE_INDEX                      6
#define MEMTYPE_INDEXNAME                  7
#define MEMTYPE_MAPPING                    8
#define MEMTYPE_MAPPINGNODE                9
#define MEMTYPE_CMDSOURCE_MAPTEXT         10
#define MEMTYPE_CMDSOURCE_MAPDATA         11
#define MEMTYPE_CMDSOURCE_SCRIPT          12
#define MEMTYPE_CMDSOURCE_DELIMINATOR     13
#define MEMTYPE_CMDSOURCE_THREADDATA      14
#define MEMTYPE_CMDSOURCE_INDEXDATA       15
#define MEMTYPE_RBNODE                    16
#define MEMTYPE_COUNT                     17


void heapInitialize ();
void *heapAlloc (size_t size, int type);
void heapFree (void *p, int type);
char *heapStrdup (char *psz, int type);
void *heapRealloc (void *old, int size, int type);
