/*
  log.h
  Jeff McElroy
  jmcelroy11@sio.midco.net
*/

/*
    ypanything, an NIS gateway to non-NIS sources
    Copyright (C) 2004  Jeff McElroy <jmcelroy11@sio.midco.net>
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA                                                                 
*/

#define LOG_DEBUG     4
#define LOG_STATUS    3
#define LOG_MEMORY    2
#define LOG_ERROR     1
#define LOG_CRIT      0


void log_func (char *fileName, char *function, int line, int logPriority,
	       char *format, ...);

void logSetLevel (int minLevel);
void logSetFile (char *fileName);
#define log(priority, format, args...) log_func(__FILE__, __FUNCTION__, __LINE__, priority, format, ## args)
