/*
  mappingTest.c
  Jeff McElroy
  jmcelroy11@sio.midco.net
*/

/*
    ypanything, an NIS gateway to non-NIS sources
    Copyright (C) 2004  Jeff McElroy <jmcelroy11@sio.midco.net>
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA                                                                 
*/

#include <stdio.h>
#include <string.h>

#include "heap.h"
#include "mapping.h"

int main (int argc, char *argv[])
{
  int i;
  char *key;
  int keyLength;
  char *value;
  int valueLength;
  int done;
  MAPPING *mapping;

  while (1) {
    mapping = mappingOpen ();
    for (i = 0; i < 25000; i++) {
      key = (char *) heapAlloc (32, MEMTYPE_UNDEFINED);
      sprintf (key, "key %d", i);
      value = (char *) heapAlloc (32, MEMTYPE_UNDEFINED);
      sprintf (value, "value %d", i);
      mappingSet (mapping, key, strlen (key), value, strlen (value));
    }

    for
      (done =
       mappingGetFirst (mapping, (void *) &key, &keyLength, (void *) &value,
			&valueLength); done == 0;
       done =
       mappingGetNext (mapping, (void *) &key, &keyLength, (void *) &value,
		       &valueLength)) {
      printf ("key = %.*s value = %.*s\n", keyLength, key, valueLength,
	      value);
    }
    mappingClose (mapping);
  }
  return 0;
}
